Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 14733)
@@ -22,5 +22,5 @@
   [PushExpression(StackType.Integer, "INTEGER.SHOVE")]
   public class IntegerShoveExpression : ShoveExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
     }
@@ -29,5 +29,5 @@
   [PushExpression(StackType.Float, "FLOAT.SHOVE")]
   public class FloatShoveExpression : ShoveExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
@@ -36,5 +36,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.SHOVE")]
   public class BooleanShoveExpression : ShoveExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
@@ -43,5 +43,5 @@
   [PushExpression(StackType.Name, "NAME.SHOVE")]
   public class NameShoveExpression : ShoveExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
@@ -50,5 +50,5 @@
   [PushExpression(StackType.Exec, "EXEC.SHOVE")]
   public class ExecShoveExpression : ShoveExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
@@ -57,5 +57,5 @@
   [PushExpression(StackType.Code, "CODE.SHOVE")]
   public class CodeShoveExpression : ShoveExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StackdepthExpressions.cs	(revision 14733)
@@ -22,5 +22,5 @@
   public class IntegerStackdepthExpression : StackdepthExpression<long> {
 
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
     }
@@ -29,5 +29,5 @@
   [PushExpression(StackType.Float, "FLOAT.STACKDEPTH")]
   public class FloatStackdepthExpression : StackdepthExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
@@ -36,5 +36,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.STACKDEPTH")]
   public class BooleanStackdepthExpression : StackdepthExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
@@ -43,5 +43,5 @@
   [PushExpression(StackType.Name, "NAME.STACKDEPTH")]
   public class NameStackdepthExpression : StackdepthExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
@@ -50,5 +50,5 @@
   [PushExpression(StackType.Exec, "EXEC.STACKDEPTH")]
   public class ExecStackdepthExpression : StackdepthExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
@@ -57,5 +57,5 @@
   [PushExpression(StackType.Code, "CODE.STACKDEPTH")]
   public class CodeStackdepthExpression : StackdepthExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatelessExpression.cs	(revision 14733)
@@ -3,5 +3,5 @@
     private readonly int hashCode;
     protected StatelessExpression() {
-      this.hashCode = this.GetType().FullName.GetHashCode();
+      this.hashCode = this.GetType().GetHashCode();
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 14733)
@@ -20,5 +20,5 @@
   [PushExpression(StackType.Integer, "INTEGER.SWAP")]
   public class IntegerSwapExpression : SwapExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.IntegerStack);
     }
@@ -27,5 +27,5 @@
   [PushExpression(StackType.Float, "FLOAT.SWAP")]
   public class FloatSwapExpression : SwapExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.FloatStack);
     }
@@ -34,5 +34,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.SWAP")]
   public class BooleanSwapExpression : SwapExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.BooleanStack);
     }
@@ -41,5 +41,5 @@
   [PushExpression(StackType.Name, "NAME.SWAP")]
   public class NameSwapExpression : SwapExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.NameStack);
     }
@@ -48,5 +48,5 @@
   [PushExpression(StackType.Exec, "EXEC.SWAP")]
   public class ExecSwapExpression : SwapExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.ExecStack);
     }
@@ -55,5 +55,5 @@
   [PushExpression(StackType.Code, "CODE.SWAP")]
   public class CodeSwapExpression : SwapExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       Eval(interpreter.CodeStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 14733)
@@ -48,5 +48,5 @@
   [PushExpression(StackType.Integer, "INTEGER.YANKDUP")]
   public class IntegerYankDuplicateExpression : YankDuplicateExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack);
     }
@@ -55,5 +55,5 @@
   [PushExpression(StackType.Float, "FLOAT.YANKDUP")]
   public class FloatYankDuplicateExpression : YankDuplicateExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
@@ -62,5 +62,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.YANKDUP")]
   public class BooleanYankDuplicateExpression : YankDuplicateExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
@@ -69,5 +69,5 @@
   [PushExpression(StackType.Name, "NAME.YANKDUP")]
   public class NameYankDuplicateExpression : YankDuplicateExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
@@ -76,5 +76,5 @@
   [PushExpression(StackType.Exec, "EXEC.YANKDUP")]
   public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
@@ -83,5 +83,5 @@
   [PushExpression(StackType.Code, "CODE.YANKDUP")]
   public class CodeYankDuplicateExpression : YankDuplicateExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 14733)
@@ -24,5 +24,5 @@
   [PushExpression(StackType.Integer, "INTEGER.YANK")]
   public class IntegerYankExpression : YankExpression<long> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
     }
@@ -31,5 +31,5 @@
   [PushExpression(StackType.Float, "FLOAT.YANK")]
   public class FloatYankExpression : YankExpression<double> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
     }
@@ -38,5 +38,5 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.YANK")]
   public class BooleanYankExpression : YankExpression<bool> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
     }
@@ -45,5 +45,5 @@
   [PushExpression(StackType.Name, "NAME.YANK")]
   public class NameYankExpression : YankExpression<string> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.NameStack, interpreter.IntegerStack);
     }
@@ -52,5 +52,5 @@
   [PushExpression(StackType.Exec, "EXEC.YANK")]
   public class ExecYankExpression : YankExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
     }
@@ -59,5 +59,5 @@
   [PushExpression(StackType.Code, "CODE.YANK")]
   public class CodeYankExpression : YankExpression<Expression> {
-    public override void Eval(IPushGpInterpreter interpreter) {
+    public override void Eval(IPushInterpreter interpreter) {
       this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Generators/CodeGenerator.cs	(revision 14733)
@@ -19,5 +19,5 @@
   public static class CodeGenerator {
 
-    public static PushProgram RandomProgram(int maxPoints, IRandom random = null, IReadonlyPushGpConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
+    public static PushProgram RandomProgram(int maxPoints, IRandom random = null, IReadonlyPushConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
       var code = RandomCode(maxPoints, random, pushGpConfiguration, customExpressions);
 
@@ -25,5 +25,5 @@
     }
 
-    public static ExecExpandExpression RandomExpandExpression(int maxPoints, IRandom random = null, IReadonlyPushGpConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
+    public static ExecExpandExpression RandomExpandExpression(int maxPoints, IRandom random = null, IReadonlyPushConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
       var program = RandomProgram(maxPoints, random, pushGpConfiguration, customExpressions);
 
@@ -31,10 +31,10 @@
     }
 
-    public static IEnumerable<Expression> RandomCode(int maxPoints, IRandom random = null, IReadonlyPushGpConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
+    public static IEnumerable<Expression> RandomCode(int maxPoints, IRandom random = null, IReadonlyPushConfiguration pushGpConfiguration = null, IDictionary<string, Expression> customExpressions = null) {
       if (maxPoints == 0)
         return new Expression[0];
 
       random = random ?? new FastRandom();
-      pushGpConfiguration = pushGpConfiguration ?? new PushGpConfiguration();
+      pushGpConfiguration = pushGpConfiguration ?? new PushConfiguration();
 
       if (pushGpConfiguration.EnabledExpressions.Count == 0)
@@ -46,5 +46,5 @@
     }
 
-    private static IEnumerable<Expression> RandomCodeWithSize(int points, IRandom random, IReadonlyPushGpConfiguration pushGpConfiguration, IDictionary<string, Expression> customExpressions = null) {
+    private static IEnumerable<Expression> RandomCodeWithSize(int points, IRandom random, IReadonlyPushConfiguration pushGpConfiguration, IDictionary<string, Expression> customExpressions = null) {
       if (points == 1) {
 
@@ -70,5 +70,5 @@
     }
 
-    private static Expression CreateExpression(IRandom random, IReadonlyPushGpConfiguration pushGpConfiguration, IDictionary<string, Expression> customExpressions = null) {
+    private static Expression CreateExpression(IRandom random, IReadonlyPushConfiguration pushGpConfiguration, IDictionary<string, Expression> customExpressions = null) {
       var customCount = customExpressions == null ? 0 : customExpressions.Count - 1;
       var index = random.Next(0, pushGpConfiguration.EnabledExpressions.Count + customCount - 1);
@@ -85,5 +85,5 @@
     }
 
-    private static Expression CreateRandomErcExpression(IRandom random, IReadonlyPushGpConfiguration pushGpConfiguration) {
+    private static Expression CreateRandomErcExpression(IRandom random, IReadonlyPushConfiguration pushGpConfiguration) {
       var value = random.Next(0, 3);
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushProblem.cs	(revision 14733)
@@ -23,10 +23,10 @@
   public class PushProblem : SingleObjectiveBasicProblem<IntegerVectorEncoding>, IProblemInstanceConsumer<Data> {
     [Storable]
-    private readonly PushGpConfiguration config;
-    private PushGpInterpreterPool pool;
+    private readonly PushConfiguration config;
+    private PushInterpreterPool pool;
 
     public PushProblem() {
-      config = new PushGpConfiguration();
-      pool = new PushGpInterpreterPool(config);
+      config = new PushConfiguration();
+      pool = new PushInterpreterPool(config);
 
       InitEvents();
@@ -43,9 +43,9 @@
       : base(original, cloner) {
       config = cloner.Clone(original.config);
-      pool = new PushGpInterpreterPool(config);
+      pool = new PushInterpreterPool(config);
+
       Instructions = config;
 
       this.InitEvents();
-      this.AddDataParameter();
     }
 
@@ -54,15 +54,8 @@
     // ReSharper disable once UnusedMember.Local
     private void AfterDeserialization() {
-      pool = new PushGpInterpreterPool(config);
+      pool = new PushInterpreterPool(config);
       Instructions = config;
 
-      AddDataParameter();
       InitEvents();
-    }
-
-    [StorableHook(HookType.BeforeSerialization)]
-    // ReSharper disable once UnusedMember.Local
-    private void BeforeDeserialization() {
-      this.Parameters.Remove(DataParameter);
     }
 
@@ -181,14 +174,9 @@
         new IntValue(config.MaxPointsInRandomExpression)) { Hidden = true });
 
-      AddDataParameter();
+      Parameters.Add(new ValueParameter<Data>(DataParameterName, DataParameterDescription));
 
       Encoding.Bounds[0, 0] = 0;
       Encoding.Bounds[0, 1] = config.EnabledExpressions.Count - 1;
       Encoding.Length = config.MaxPointsInProgram;
-    }
-
-    private void AddDataParameter() {
-      if (!Parameters.ContainsKey(DataParameterName))
-        Parameters.Add(new ValueParameter<Data>(DataParameterName, DataParameterDescription));
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Problem/PushSolution.cs	(revision 14733)
@@ -14,8 +14,8 @@
     public readonly Data Data;
     public readonly IRandom Random;
-    public readonly PushGpInterpreterPool Pool;
+    public readonly PushInterpreterPool Pool;
 
     public PushSolution(PushProgram program, double quality, Data data,
-      IRandom random, PushGpInterpreterPool pool)
+      IRandom random, PushInterpreterPool pool)
       : base("Solution", "A push solution.") {
       Program = program;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Benchmark/ProblemTests.cs	(revision 14733)
@@ -141,6 +141,6 @@
 
       Expression bestProgram = null;
-      var config = new PushGpConfiguration { EvalPushLimit = 4096 };
-      var pool = new PushGpInterpreterPool(config);
+      var config = new PushConfiguration { EvalPushLimit = 4096 };
+      var pool = new PushInterpreterPool(config);
 
       var instance = new BenchmarkSuiteInstanceProvider();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14732)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Tests/Interpreter/ExpressionTest.cs	(revision 14733)
@@ -8,5 +8,5 @@
     protected PushGpInterpreter interpreter;
 
-    protected PushGpConfiguration configuration = new PushGpConfiguration { TopLevelPushCode = false };
+    protected PushConfiguration configuration = new PushConfiguration { TopLevelPushCode = false };
 
     [TestInitialize]
